# AWK BUgRePortSystem
# work started 11/29/89
# by Bob Heitman for Sierra On-Line, Inc.


BEGIN {
			FS = "~"
			RS = ""
			room = 1
			version = 2
			date = 3
			btime = 4
			whose = 5
			foundby = 6
			sysData = 7
			userData = 8
tr0 = "*****************************************************************************\n"
tr1 = "Disposition:  (Circle one)    Fixed     Ok as is     CND    by__________\n "
tr2 = "\n"
tr3 = "\n"
tr4 = "\n"
tr5 = "\n"
tr6 = "\n"
tr7 = "***************************** Q.A USE ONLY **********************************\n"
tr8 = "Ver. #:___________  FIXED: Yes  No  Ok  CND   DATE:________   INTL:_____\n"
tr9 = "*****************************************************************************\n"

}

	{
		if ("CONFIGURATION" == $1) { 
			#save mach config by reporter
			gsub(" ", "", $2)
			gsub("Drv", "", $3)
			gsub(".drv", "", $3)
			configs[$2] = $3					 	
			--NR
		} else {
			if ("BAD_SAID" == $1) { 
				#save said related specs in a separate table
				saids[bs] = $2
				++bs
				--NR
			} else {
				A[NR] = $0					# assign entire line to array
				gsub("\n", " ", A[NR])	# we want to see no new lines
			}				
		}
	}




END	{
			# sort saids and print them
			isort(saids, bs)
			for (i = 1; i <= bs; i++) {
				print saids[i]
			}
			# add a page feed before printing bugs
			printf("\f")

			# sort all elements of the array
			isort(A, NR)
			# track number of lines on page to avoid widow
			pageNum = 1
			np = pageheader(pageNum)
			nl = 0
			for (i = 1; i <= NR; i++) {
				# add a header
				page[nl] = tr0 ; ++nl
				#split the elements into fields and print the formatted output
				split(A[i], fa, "~")
				page[nl] = sprintf("Room %s  Ver %s  Date %s %s  For %s from %s\n",
					fa[room], fa[version], fa[date], fa[btime], fa[whose], fa[foundby])
				++nl

				#remove any excess white space in this line

				#wrap the sys defined field
				gsub("[ \t]+", " ", fa[sysData])
				while (length(fa[sysData])) {
					len = wrap(fa[sysData], 60)
					page[nl] = sprintf("%s\n", substr(fa[sysData], 0, len))
					++nl
					fa[sysData] = substr(fa[sysData], len + 1)
				}
				# print the configuration
				inter = fa[foundby]
				gsub(" ","",inter)
				page[nl] = sprintf("%s\n", configs[inter])
				++nl

				# add a blank line
				page[nl] = tr2 ; ++nl

				#wrap the user defined field
				gsub("[ \t]+", " ", fa[userData])
				while (length(fa[userData])) {
					len = wrap(fa[userData], 60)
					page[nl] = sprintf("%s\n", substr(fa[userData], 0, len))
					++nl
					fa[userData] = substr(fa[userData], len + 1)
				}

				# print a fancy trailer
				page[nl] = tr2 ; ++nl
				page[nl] = tr1 ; ++nl
				page[nl] = tr2 ; ++nl
				page[nl] = tr3 ; ++nl
				page[nl] = tr4 ; ++nl
				page[nl] = tr5 ; ++nl
				page[nl] = tr6 ; ++nl
				page[nl] = tr7 ; ++nl
				page[nl] = tr8 ; ++nl
				page[nl] = tr9 ; ++nl
				page[nl] = tr6 ; ++nl

				# check for a page break
				if (nl + np >= 58){
					printf("\f")
					++pageNum
					np = pageheader(pageNum)
				}
				for (k = 0; k < nl; ++k)
					printf(page[k])

				#reset line counter and adjust page counter
				np += nl
				nl = 0
			}
		}

# print a page header
function pageheader(pn) {
	printf("\n%-20s%-40s%15s\n\n", FILENAME, ctime(), "Page " pn)
	return 3
}

# sort passed array of n elements
function isort(A, n,	i,j,t) {
	for (i = 2; i <= n; i++)
		for (j = i; j > 1 && A[j-1] > A[j]; j--) {
			t = A[j-1]; A[j-1] = A[j]; A[j] = t
		}
	
}

			
# return the maximum length of this string that is less than max
function wrap(str, max, 	last, len, avail) {

	last = 0
	if ((avail = length(str)) <= max)
		return avail + 1
	while (index(substr(str, last + 1), " ") > 0){
		len = index(substr(str, last + 1), " ")
		#break if this blank exceeds maximum allowed length
		if (len + last + 1 > max)
			break
		last += len
	}
	if (last == 0)
		last = max

	return last
}

